﻿/**
* LoadVars2 by Grant Skinner. Mar 10, 2004
* Visit www.gskinner.com for documentation, updates and more free code.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/

import mx.events.EventDispatcher;

dynamic class com.gskinner.net.LoadVars2 extends LoadVars {
// define public properties:
	var timeout:Number = 7000;
	
// define private properties:
	private var tmp_timeoutID:Number;
	private var oldRemoveEventListener:Function;
	private var oldAddEventListener:Function;
	
// define functions for EventDispatcher:
	private var dispatchEvent:Function;
	var removeEventListener:Function;
	var addEventListener:Function;
	
// initialization:
	function LoadVars2() {
		super();
		EventDispatcher.initialize(this);
		oldAddEventListener = addEventListener;
		removeEventListener = __removeEventListener;
		removeAddEventListener = removeEventListener;
		addEventListener = __addEventListener;
		ASSetPropFlags(this,["timeout","tmp_timeoutID","dispatchEvent","dispatchQueue","addEventListener","removeEventListener","load","sendAndLoad","setTimeOut","clearTimeOut","onTimeOut","oldAddEventListener","__addEventListener","oldRemoveEventListener","__removeEventListener"],7);
	}
	
// public methods:
	function load(p_url):Void {
		setTimeout();
		super.load(p_url);
	}
	
	function sendAndLoad(p_url:String,p_targetObject:Object,p_method:String):Void {
		setTimeout();
		super.sendAndLoad(p_url,p_targetObject,p_method);
	}
	
// private methods:
	private function setTimeout():Void {
		clearTimeout();
		tmp_timeoutID = setInterval(this,"onTimeout",timeout);
	}
	
	private function clearTimeout():Void {
		clearInterval(tmp_timeoutID);
		delete(tmp_timeoutID);
	}
	
	private function onLoad(p_success:Boolean):Void {
		if (!tmp_timeoutID) { loaded=false; return; }
		clearTimeout();
		dispatchEvent({target:this,type:"load",success:p_success});
	}
	
	private function __onData(p_src:String) {
		if (!tmp_timeoutID) { loaded=false; return; }
		clearTimeout();
		dispatchEvent({target:this,type:"data",src:p_src});
	}
	
	private function onTimeout():Void {
		clearTimeout();
		loaded = false;
		if (onData != undefined) {
			dispatchEvent({target:this,type:"data",src:undefined});
		} else {
			dispatchEvent({target:this,type:"load",success:false});
		}
	}
	
	private function __addEventListener(p_event:String,p_listenerObject:Object):Void {
		if (p_event == "data") { onData = __onData; }
		oldAddEventListener(p_event,p_listenerObject);
	}
	private function __removeEventListener(p_event:String,p_listenerObject:Object):Void {
		if (p_event == "data") { delete(onData); }
		oldRemoveEventListener(p_event,p_listenerObject);
	}
}